<template>
  <div class="view-list">
    <view-bar>{{ title }}</view-bar>
    <view-search
      v-on:export-csv="$emit('export-csv')"
      v-on:model-search="$emit('model-search', $event)"
    />
    <list-body :status="status" :length="length">
      <slot></slot>
      <div
        v-if="button && napi.getCurrentUserPermId() > 1"
        class="filler"
      ></div>
    </list-body>
    <view-button
      v-if="button && napi.getCurrentUserPermId() > 1"
      :to="button_link"
      :text="button_title"
    />
    <teleport to="#modals">
      <router-view v-on:model-reload="$emit('model-reload')"></router-view>
    </teleport>
  </div>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import ViewBar from "@/components/ViewBar.vue";
import ViewSearch from "@/components/ViewSearch.vue";
import ListBody from "@/components/list/ListBody.vue";
import ViewButton from "@/components/ViewButton.vue";
import { NApi } from "@/interfaces/connector";

@Options({
  props: {
    title: String,
    button_title: String,
    button_link: String,
    status: Number,
    button: Boolean,
    length: Number,
  },
  components: {
    ViewBar,
    ViewSearch,
    ListBody,
    ViewButton,
  },
  emits: ["export-csv", "model-reload", "model-search"],
})
export default class ViewList extends Vue {
  public name!: string;
  public button_title!: string;
  public button_link?: string;
  public is_loading?: boolean;
  public length!: number;

  public napi = NApi;

  public button = true;
}
</script>

<style lang="scss" scoped>
.view-list {
  display: grid;
  height: 100%;
  grid-template-rows: auto auto 1fr;
  overflow: hidden;
  position: relative;

  .filler {
    height: 100px;
  }
}
</style>
